Index: /trunk/configure.in
===================================================================
--- /trunk/configure.in	(revision 1269)
+++ /trunk/configure.in	(revision 1270)
@@ -1,3 +1,4 @@
-AC_INIT([Rappture], [1.1], [rappture@nanohub.org])
+AC_INIT([Rappture],[1.1],[rappture@nanohub.org])
+dnl AC_CONFIG_HEADER(src/core/RpConfig.h)
 AC_CONFIG_AUX_DIR(cf)
 
@@ -35,10 +36,10 @@
 AC_PROG_F77([g77 gfortran f77 fort77 f90 xlf xlf90 fl32])
 
-AC_LANG_C
+AC_LANG([C])
 
 AC_HEADER_STDC
 AC_CHECK_FUNC(atol,,AC_MSG_ERROR(oops! no atol ?!?))
 
-AC_LANG_CPLUSPLUS
+AC_LANG([C++])
 
 AC_CHECK_LIB(m, main,,AC_MSG_ERROR(librappture requires libm))
@@ -94,5 +95,5 @@
 done
 if test "x${make_command}" = "x" ; then
-  AC_ERROR([Requires GNU make. You can specify a version with \$MAKE])
+  AC_MSG_ERROR([Requires GNU make. You can specify a version with \$MAKE])
 fi
 AC_SUBST(MAKE, ${make_command})
@@ -483,5 +484,5 @@
 
 dnl read Makefile.in and write Makefile
-AC_OUTPUT( [
+AC_CONFIG_FILES([
     Makefile
     packages/Makefile
@@ -490,4 +491,5 @@
     src/core2/Makefile
     src/objects/Makefile
+    src/objects/RpHash.h
     gui/Makefile
     gui/apps/Makefile
@@ -576,2 +578,3 @@
     test/src/Makefile
 ])
+AC_OUTPUT
Index: /trunk/src/objects/RpChain.c
===================================================================
--- /trunk/src/objects/RpChain.c	(revision 1270)
+++ /trunk/src/objects/RpChain.c	(revision 1270)
@@ -0,0 +1,445 @@
+/*
+ * bltChain.c --
+ *
+ *  The module implements a generic linked list package.
+ *
+ * Copyright 1991-1998 Lucent Technologies, Inc.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that the copyright notice and warranty
+ * disclaimer appear in supporting documentation, and that the names
+ * of Lucent Technologies any of their entities not be used in
+ * advertising or publicity pertaining to distribution of the software
+ * without specific, written prior permission.
+ *
+ * Lucent Technologies disclaims all warranties with regard to this
+ * software, including all implied warranties of merchantability and
+ * fitness.  In no event shall Lucent Technologies be liable for any
+ * special, indirect or consequential damages or any damages
+ * whatsoever resulting from loss of use, data or profits, whether in
+ * an action of contract, negligence or other tortuous action, arising
+ * out of or in connection with the use or performance of this
+ * software.
+ */
+
+#include "RpInt.h"
+#include "RpChain.h"
+
+#ifndef ALIGN
+#define ALIGN(a) \
+    (((size_t)a + (sizeof(double) - 1)) & (~(sizeof(double) - 1)))
+#endif /* ALIGN */
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainCreate --
+ *
+ *  Creates a new linked list (chain) structure and initializes 
+ *  its pointers;
+ *
+ * Results:
+ *  Returns a pointer to the newly created chain structure.
+ *
+ *----------------------------------------------------------------------
+ */
+Rp_Chain *
+Rp_ChainCreate()
+{
+    Rp_Chain *chainPtr;
+
+    chainPtr = (Rp_Chain *) Rp_Malloc(sizeof(Rp_Chain));
+    if (chainPtr != NULL) {
+        Rp_ChainInit(chainPtr);
+    }
+    return chainPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainAllocLink --
+ *
+ *  Creates a new chain link.  Unlink Rp_ChainNewLink, this 
+ *  routine also allocates extra memory in the node for data.
+ *
+ * Results:
+ *  The return value is the pointer to the newly created entry.
+ *
+ *----------------------------------------------------------------------
+ */
+Rp_ChainLink *
+Rp_ChainAllocLink(extraSize)
+    unsigned int extraSize;
+{
+    Rp_ChainLink *linkPtr;
+    unsigned int linkSize;
+
+    linkSize = ALIGN(sizeof(Rp_ChainLink));
+    linkPtr = Rp_Calloc(1, linkSize + extraSize);
+    assert(linkPtr);
+    if (extraSize > 0) {
+        /* Point clientData at the memory beyond the normal structure. */
+        linkPtr->clientData = (ClientData)((char *)linkPtr + linkSize);
+    }
+    return linkPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainNewLink --
+ *
+ *  Creates a new link.
+ *
+ * Results:
+ *  The return value is the pointer to the newly created link.
+ *
+ *----------------------------------------------------------------------
+ */
+Rp_ChainLink *
+Rp_ChainNewLink()
+{
+    Rp_ChainLink *linkPtr;
+
+    linkPtr = (Rp_ChainLink *) Rp_Malloc(sizeof(Rp_ChainLink));
+    assert(linkPtr);
+    linkPtr->clientData = NULL;
+    linkPtr->nextPtr = linkPtr->prevPtr = NULL;
+    return linkPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainReset --
+ *
+ *  Removes all the links from the chain, freeing the memory for
+ *  each link.  Memory pointed to by the link (clientData) is not
+ *  freed.  It's the caller's responsibility to deallocate it.
+ *
+ * Results:
+ *  None.
+ *
+ *---------------------------------------------------------------------- 
+ */
+void
+Rp_ChainReset(chainPtr)
+    Rp_Chain *chainPtr;	/* Chain to clear */
+{
+    if (chainPtr != NULL) {
+        Rp_ChainLink *oldPtr;
+        Rp_ChainLink *linkPtr = chainPtr->headPtr;
+
+        while (linkPtr != NULL) {
+            oldPtr = linkPtr;
+            linkPtr = linkPtr->nextPtr;
+            Rp_Free(oldPtr);
+        }
+        Rp_ChainInit(chainPtr);
+    }
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainDestroy
+ *
+ *     Frees all the nodes from the chain and deallocates the memory
+ *     allocated for the chain structure itself.  It's assumed that
+ *     the chain was previous allocated by Rp_ChainCreate.
+ *
+ * Results:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainDestroy(chainPtr)
+    Rp_Chain *chainPtr;
+{
+    if (chainPtr != NULL) {
+        Rp_ChainReset(chainPtr);
+        Rp_Free(chainPtr);
+    }
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainInit --
+ *
+ *  Initializes a linked list.
+ *
+ * Results:
+ *  None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainInit(chainPtr)
+    Rp_Chain *chainPtr;
+{
+    chainPtr->nLinks = 0;
+    chainPtr->headPtr = chainPtr->tailPtr = NULL;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainLinkAfter --
+ *
+ *  Inserts an entry following a given entry.
+ *
+ * Results:
+ *  None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainLinkAfter(chainPtr, linkPtr, afterPtr)
+    Rp_Chain *chainPtr;
+    Rp_ChainLink *linkPtr, *afterPtr;
+{
+    if (chainPtr->headPtr == NULL) {
+        chainPtr->tailPtr = chainPtr->headPtr = linkPtr;
+    } else {
+        if (afterPtr == NULL) {
+            /* Prepend to the front of the chain */
+            linkPtr->nextPtr = chainPtr->headPtr;
+            linkPtr->prevPtr = NULL;
+            chainPtr->headPtr->prevPtr = linkPtr;
+            chainPtr->headPtr = linkPtr;
+        } else {
+            linkPtr->nextPtr = afterPtr->nextPtr;
+            linkPtr->prevPtr = afterPtr;
+            if (afterPtr == chainPtr->tailPtr) {
+                chainPtr->tailPtr = linkPtr;
+            } else {
+                afterPtr->nextPtr->prevPtr = linkPtr;
+            }
+            afterPtr->nextPtr = linkPtr;
+        }
+    }
+    chainPtr->nLinks++;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainLinkBefore --
+ *
+ *  Inserts a link preceding a given link.
+ *
+ * Results:
+ *  None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainLinkBefore(chainPtr, linkPtr, beforePtr)
+    Rp_Chain *chainPtr;         /* Chain to contain new entry */
+    Rp_ChainLink *linkPtr;      /* New entry to be inserted */
+    Rp_ChainLink *beforePtr;    /* Entry to link before */
+{
+    if (chainPtr->headPtr == NULL) {
+        chainPtr->tailPtr = chainPtr->headPtr = linkPtr;
+    } else {
+        if (beforePtr == NULL) {
+            /* Append to the end of the chain. */
+            linkPtr->nextPtr = NULL;
+            linkPtr->prevPtr = chainPtr->tailPtr;
+            chainPtr->tailPtr->nextPtr = linkPtr;
+            chainPtr->tailPtr = linkPtr;
+        } else {
+            linkPtr->prevPtr = beforePtr->prevPtr;
+            linkPtr->nextPtr = beforePtr;
+            if (beforePtr == chainPtr->headPtr) {
+                chainPtr->headPtr = linkPtr;
+            } else {
+                beforePtr->prevPtr->nextPtr = linkPtr;
+            }
+            beforePtr->prevPtr = linkPtr;
+        }
+    }
+    chainPtr->nLinks++;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainUnlinkLink --
+ *
+ *	Unlinks a link from the chain. The link is not deallocated, 
+ *	but only removed from the chain.
+ *
+ * Results:
+ *	None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainUnlinkLink(chainPtr, linkPtr)
+    Rp_Chain *chainPtr;
+    Rp_ChainLink *linkPtr;
+{
+    int unlinked;       /* Indicates if the link is actually
+                         * removed from the chain. */
+
+    unlinked = FALSE;
+    if (chainPtr->headPtr == linkPtr) {
+        chainPtr->headPtr = linkPtr->nextPtr;
+        unlinked = TRUE;
+    }
+    if (chainPtr->tailPtr == linkPtr) {
+        chainPtr->tailPtr = linkPtr->prevPtr;
+        unlinked = TRUE;
+    }
+    if (linkPtr->nextPtr != NULL) {
+        linkPtr->nextPtr->prevPtr = linkPtr->prevPtr;
+        unlinked = TRUE;
+    }
+    if (linkPtr->prevPtr != NULL) {
+        linkPtr->prevPtr->nextPtr = linkPtr->nextPtr;
+        unlinked = TRUE;
+    }
+    if (unlinked) {
+        chainPtr->nLinks--;
+    }
+    linkPtr->prevPtr = linkPtr->nextPtr = NULL;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainDeleteLink --
+ *
+ *  Unlinks and also frees the given link.
+ *
+ * Results:
+ *  None.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainDeleteLink(chainPtr, linkPtr)
+    Rp_Chain *chainPtr;
+    Rp_ChainLink *linkPtr;
+{
+    Rp_ChainUnlinkLink(chainPtr, linkPtr);
+    Rp_Free(linkPtr);
+}
+
+Rp_ChainLink *
+Rp_ChainAppend(chainPtr, clientData)
+    Rp_Chain *chainPtr;
+    ClientData clientData;
+{
+    Rp_ChainLink *linkPtr;
+
+    linkPtr = Rp_ChainNewLink();
+    Rp_ChainLinkBefore(chainPtr, linkPtr, (Rp_ChainLink *)NULL);
+    Rp_ChainSetValue(linkPtr, clientData);
+    return linkPtr;
+}
+
+Rp_ChainLink *
+Rp_ChainPrepend(chainPtr, clientData)
+    Rp_Chain *chainPtr;
+    ClientData clientData;
+{
+    Rp_ChainLink *linkPtr;
+
+    linkPtr = Rp_ChainNewLink();
+    Rp_ChainLinkAfter(chainPtr, linkPtr, (Rp_ChainLink *)NULL);
+    Rp_ChainSetValue(linkPtr, clientData);
+    return linkPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainGetNthLink --
+ *
+ *  Find the link at the given position in the chain.
+ *
+ * Results:
+ *  Returns the pointer to the link, if that numbered link
+ *  exists. Otherwise NULL.
+ *
+ *----------------------------------------------------------------------
+ */
+Rp_ChainLink *
+Rp_ChainGetNthLink(chainPtr, position)
+    Rp_Chain *chainPtr; /* Chain to traverse */
+    int position;       /* Index of link to select from front
+                         * or back of the chain. */
+{
+    Rp_ChainLink *linkPtr;
+
+    if (chainPtr != NULL) {
+        for (linkPtr = chainPtr->headPtr; linkPtr != NULL;
+            linkPtr = linkPtr->nextPtr) {
+            if (position == 0) {
+                return linkPtr;
+            }
+            position--;
+        }
+    }
+    return NULL;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_ChainSort --
+ *
+ *  Sorts the chain according to the given comparison routine.
+ *
+ * Results:
+ *  None.
+ *
+ * Side Effects:
+ *  The chain is reordered.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_ChainSort(chainPtr, proc)
+    Rp_Chain *chainPtr;	/* Chain to traverse */
+    Rp_ChainCompareProc *proc;
+{
+    Rp_ChainLink **linkArr;
+    register Rp_ChainLink *linkPtr;
+    register int i;
+
+    if (chainPtr->nLinks < 2) {
+        return;
+    }
+    linkArr = (Rp_ChainLink **) Rp_Malloc(sizeof(Rp_ChainLink *) * (chainPtr->nLinks + 1));
+    if (linkArr == NULL) {
+        return;         /* Out of memory. */
+    }
+    i = 0;
+    for (linkPtr = chainPtr->headPtr; linkPtr != NULL;
+         linkPtr = linkPtr->nextPtr) {
+        linkArr[i++] = linkPtr;
+    }
+    qsort((char *)linkArr, chainPtr->nLinks, sizeof(Rp_ChainLink *),
+        (QSortCompareProc *)proc);
+
+    /* Rethread the chain. */
+    linkPtr = linkArr[0];
+    chainPtr->headPtr = linkPtr;
+    linkPtr->prevPtr = NULL;
+    for (i = 1; i < chainPtr->nLinks; i++) {
+        linkPtr->nextPtr = linkArr[i];
+        linkPtr->nextPtr->prevPtr = linkPtr;
+        linkPtr = linkPtr->nextPtr;
+    }
+    chainPtr->tailPtr = linkPtr;
+    linkPtr->nextPtr = NULL;
+    Rp_Free(linkArr);
+}
Index: /trunk/src/objects/RpChain.h
===================================================================
--- /trunk/src/objects/RpChain.h	(revision 1270)
+++ /trunk/src/objects/RpChain.h	(revision 1270)
@@ -0,0 +1,85 @@
+/*
+ * bltChain.h --
+ *
+ * Copyright 1993-2000 Lucent Technologies, Inc.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that the copyright notice and warranty
+ * disclaimer appear in supporting documentation, and that the names
+ * of Lucent Technologies any of their entities not be used in
+ * advertising or publicity pertaining to distribution of the software
+ * without specific, written prior permission.
+ *
+ * Lucent Technologies disclaims all warranties with regard to this
+ * software, including all implied warranties of merchantability and
+ * fitness.  In no event shall Lucent Technologies be liable for any
+ * special, indirect or consequential damages or any damages
+ * whatsoever resulting from loss of use, data or profits, whether in
+ * an action of contract, negligence or other tortuous action, arising
+ * out of or in connection with the use or performance of this
+ * software.
+ */
+#ifndef _RP_CHAIN_H
+#define _RP_CHAIN_H
+
+typedef struct Rp_ChainLinkStruct Rp_ChainLink;
+
+/*
+ * A Rp_ChainLink is the container structure for the Rp_Chain.
+ */
+
+struct Rp_ChainLinkStruct {
+    Rp_ChainLink *prevPtr;  /* Link to the previous link */
+    Rp_ChainLink *nextPtr;  /* Link to the next link */
+    ClientData clientData;  /* Pointer to the data object */
+};
+
+typedef int (Rp_ChainCompareProc) _ANSI_ARGS_((Rp_ChainLink **l1PtrPtr, 
+    Rp_ChainLink **l2PtrPtr));
+
+/*
+ * A Rp_Chain is a doubly chained list structure.
+ */
+typedef struct {
+    Rp_ChainLink *headPtr;  /* Pointer to first element in chain */
+    Rp_ChainLink *tailPtr;  /* Pointer to last element in chain */
+    int nLinks;             /* Number of elements in chain */
+} Rp_Chain;
+
+extern void Rp_ChainInit _ANSI_ARGS_((Rp_Chain * chainPtr));
+extern Rp_Chain *Rp_ChainCreate _ANSI_ARGS_(());
+extern void Rp_ChainDestroy _ANSI_ARGS_((Rp_Chain * chainPtr));
+extern Rp_ChainLink *Rp_ChainNewLink _ANSI_ARGS_((void));
+extern Rp_ChainLink *Rp_ChainAllocLink _ANSI_ARGS_((unsigned int extraSize));
+extern Rp_ChainLink *Rp_ChainAppend _ANSI_ARGS_((Rp_Chain * chainPtr,
+    ClientData clientData));
+extern Rp_ChainLink *Rp_ChainPrepend _ANSI_ARGS_((Rp_Chain * chainPtr,
+    ClientData clientData));
+extern void Rp_ChainReset _ANSI_ARGS_((Rp_Chain * chainPtr));
+extern void Rp_ChainLinkAfter _ANSI_ARGS_((Rp_Chain * chainPtr,
+    Rp_ChainLink * linkPtr, Rp_ChainLink * afterLinkPtr));
+extern void Rp_ChainLinkBefore _ANSI_ARGS_((Rp_Chain * chainPtr,
+    Rp_ChainLink * linkPtr, Rp_ChainLink * beforeLinkPtr));
+extern void Rp_ChainUnlinkLink _ANSI_ARGS_((Rp_Chain * chainPtr,
+    Rp_ChainLink * linkPtr));
+extern void Rp_ChainDeleteLink _ANSI_ARGS_((Rp_Chain * chainPtr,
+    Rp_ChainLink * linkPtr));
+extern Rp_ChainLink *Rp_ChainGetNthLink _ANSI_ARGS_((Rp_Chain * chainPtr, int n));
+extern void Rp_ChainSort _ANSI_ARGS_((Rp_Chain * chainPtr,
+    Rp_ChainCompareProc * proc));
+
+#define Rp_ChainGetLength(c)        (((c) == NULL) ? 0 : (c)->nLinks)
+#define Rp_ChainFirstLink(c)        (((c) == NULL) ? NULL : (c)->headPtr)
+#define Rp_ChainLastLink(c)         (((c) == NULL) ? NULL : (c)->tailPtr)
+#define Rp_ChainPrevLink(l)         ((l)->prevPtr)
+#define Rp_ChainNextLink(l)         ((l)->nextPtr)
+#define Rp_ChainGetValue(l)         ((l)->clientData)
+#define Rp_ChainSetValue(l, value)  ((l)->clientData = (ClientData)(value))
+#define Rp_ChainAppendLink(c, l) \
+    (Rp_ChainLinkBefore((c), (l), (Rp_ChainLink *)NULL))
+#define Rp_ChainPrependLink(c, l) \
+    (Rp_ChainLinkAfter((c), (l), (Rp_ChainLink *)NULL))
+
+#endif /* _RP_CHAIN_H */
